//ICC-AVR application builder : 04.09.2009 9:06:14
// Target : M88
// Crystal: 8.0000Mhz

#include <iom88v.h>
#include <macros.h>
#include <string.h>



//Signal bit definitions
#define	ROW0	0	//PB0
#define	ROW1	1	//PB1
#define	ROW2	2	//PB2
#define	ROW3	3	//PB3
#define	COW0	4	//PB4
#define	COW1	5	//PB5
#define	COW2	6	//PB6
#define	BEEP	7	//PB7
#define	STR		0	//PC0
#define	DAT		1	//PC1
#define	CLK		2	//PC2
#define	SDA		4	//PC4
#define	SCL		5	//PC5
#define	ADC1	6	//PC6
#define	LCD_RS	0	//PD0
#define	LCD_RW	1	//PD1
#define	SEC		2	//PD2
#define	LCD_E	3	//PD3
#define	LDAT0	4	//PD4
#define	LDAT1	5	//PD5
#define	LDAT2	6	//PD6
#define	LDAT3	7	//PD7


#define SetBeep		PORTB |= BIT(BEEP)
#define ClrBeep		PORTB &= ~BIT(BEEP)

//
#define LcdBufSize		 16
#define LcdBufMask		 LcdBufSize - 1
#if ( LcdBufSize & LcdBufMask )
	#error RX buffer size is not a power of 2
#endif
#define CodeMaxLength 4
unsigned char KeyBuffer[CodeMaxLength];
static unsigned char LcdBuf[LcdBufSize];
flash static unsigned char KPD_Array[4][3] = { {'1','2','3'},{'4','5','6'},{'7','8','9'},{'*','0','#'}};
unsigned char CODE_ACCESS[CodeMaxLength+1] = {"1234 "};
unsigned char KPD_KeyPressed;
unsigned char KPD_LastKey;
unsigned char KPD_ScanRow;
unsigned char KPD_KeyDown;

unsigned char temp,bounce,key;
unsigned char Beep = 0;
 
unsigned char KPD_GetKey(void)
{
  if (KPD_KeyPressed)
  {
    KPD_KeyPressed = 0;
    return (KPD_LastKey);
  }
  else
    return (0);
}

 void CheckAccess(void)
{
  unsigned char i;

  for (i=0;i<CodeMaxLength;i++)
    if (CODE_ACCESS[CodeMaxLength-i-1] != KeyBuffer[i])
      return;

 
  KPD_KeyPressed = 0;
  KPD_LastKey = 0;
  KPD_ScanRow = 0;
  KPD_KeyDown = 0;
}
 
 
 void Delay(unsigned int ms)
 {
   unsigned char delay;
 
   do
   {
     delay = 166;                      // 6 cycles/loop
     while(delay--);
   }
   while (ms--);
 }

void port_init(void)
{
 PORTB = 0xf0;
 DDRB  = 0x0f;
 PORTC = 0x77; //m103 output only
 DDRC  = 0x07;
 PORTD = 0xF4;
 DDRD  = 0x0B;
}


//TIMER1 initialize - prescale:8
// WGM: 0) Normal, TOP=0xFFFF
// desired value: 2mSec
// actual value:  2,000mSec (0,0%)
void timer1_init(void)
{
 TCCR1B = 0x00; //stop
 TCNT1H = 0xF8; //setup
 TCNT1L = 0x30;
 OCR1AH = 0x07;
 OCR1AL = 0xD0;
 OCR1BH = 0x07;
 OCR1BL = 0xD0;
 ICR1H  = 0x07;
 ICR1L  = 0xD0;
 TCCR1A = 0x00;
 TCCR1B = 0x02; //start Timer
}
#pragma interrupt_handler pcint0_isr:4
void pcint0_isr(void)
{
//pin change

 unsigned int delay=22856;             // 7 cycles per count, 20 ms @ 8 MHz
  unsigned char column;

  PCICR &= ~(1 << PCIE0);             // disable pin change int for de-bounce
  
  do
  {}
  while(delay--);                     // de-bounce: allow inputs to settle
  PCICR |= (1 << PCIE0);              // enable pin change ints

  column = (~PINB) & 0x70;
  switch (column >> 4)
  {
    case  0x00: KPD_KeyDown = 0;
                break;
    case  0x01: KPD_LastKey = KPD_Array[KPD_ScanRow][0];
                if (!KPD_KeyDown)
                  KPD_KeyPressed = 1;               // must release key before press recorded
                KPD_KeyDown = 1;
                break;
    case  0x02: KPD_LastKey = KPD_Array[KPD_ScanRow][1];
                if (!KPD_KeyDown)
                  KPD_KeyPressed = 1;               // must release key before press recorded
                KPD_KeyDown = 1;
                break;
    case  0x04: KPD_LastKey = KPD_Array[KPD_ScanRow][2];
                if (!KPD_KeyDown)
                  KPD_KeyPressed = 1;               // must release key before press recorded
                KPD_KeyDown = 1;
                break;
    case  0x08: KPD_LastKey = KPD_Array[KPD_ScanRow][3];
                if (!KPD_KeyDown)
                  KPD_KeyPressed = 1;               // must release key before press recorded
                KPD_KeyDown = 1;
                break;
    default:    KPD_LastKey = 0;
                KPD_KeyPressed = 0;
  }
  //SEI();
}
#pragma interrupt_handler timer1_ovf_isr:14
void timer1_ovf_isr(void)
{
 //TIMER1 has overflowed
 TCNT1H = 0xF8; //reload counter high value
 TCNT1L = 0x30; //reload counter low value
  if (!KPD_KeyDown)
  {
    PORTB |= (1 << KPD_ScanRow);        // set pin high
    if (++KPD_ScanRow > 3)
      KPD_ScanRow = 0;
    PORTB &= ~(1 << KPD_ScanRow);       // set pin low
  }
 //  
 if (Beep != 0x00)
 	{
	Beep--;
	SetBeep;
 	}
 else
 	{
	ClrBeep;
 	}	
 
 
 
 
}
//TWI initialize
// bit rate:10
void twi_init(void)
{
 TWCR= 0X00; //disable twi
 TWBR= 0x0A; //set bit rate
 TWSR= 0x00; //set prescale
 TWAR= 0x00; //set slave address
 TWCR= 0x44; //enable twi
 
}

//ADC initialize
// Conversion time: 3uS
void adc_init(void)
{
 ADCSRA = 0x00; //disable adc
 ADMUX = 0x00;  //select adc input 0
 ACSR  = 0x80;
 ADCSRB = 0x00;
 ADCSRA = 0x81;
 
}

#pragma interrupt_handler int0_isr:2
void int0_isr(void)
{
 //external interupt on INT0
 
}

//call this routine to initialize all peripherals
void init_devices(void)
{
 //stop errant interrupts until set up
 CLI(); //disable all interrupts
 port_init();
 twi_init();
 adc_init();
 timer1_init();

 MCUCR = 0x10;
 EICRA = 0x00; //extended ext ints
 EIMSK = 0x01;
 
 TIMSK0 = 0x00; //timer 0 interrupt sources
 TIMSK1 = 0x01; //timer 1 interrupt sources
 TIMSK2 = 0x00; //timer 2 interrupt sources
 
 PCMSK0 = 0x70; //pin change mask 0 
 PCMSK1 = 0x00; //pin change mask 1 
 PCMSK2 = 0x00; //pin change mask 2
 PCICR = 0x01; //pin change enable 
 PRR = 0x00; //power controller
 SEI(); //re-enable interrupts
 //all peripherals are now initialized
}

//
void main(void)
{
 init_devices();
 //insert your functional code here...
 KPD_KeyPressed = 0;
 KPD_LastKey = 0;
 KPD_ScanRow = 0;
 KPD_KeyDown = 0;
 
 
 while (1)
 	{
	unsigned char i;
	
	 if(KPD_KeyPressed)
	 {
	 for (i=CodeMaxLength;i>0;i--)
      KeyBuffer[i] = KeyBuffer[i-1];  // scroll input buffer
    KeyBuffer[0] = KPD_GetKey();
	Beep = 25;
    CheckAccess();}
	}
	//}
 
}

